import junit.framework.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import static org.junit.Assert.*;

public class ArrazTest {

    Arraz arraz = new Arraz();

    @Test
    public void test1SumOfArray(){
        int[] arr = new int[]{5,6};
        int expected = 11;
        int actual = arraz.sumOfArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2SumOfArray(){
        int[] arr = new int[]{0,3,6};
        int expected = 9;
        int actual = arraz.sumOfArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1SumOfDoublesArray(){
        double[] arr = new double[]{5.0,6.3};
        double expected = 11.3;
        double actual = arraz.sumOfDoublesArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2SumOfDoublesArray(){
        double[] arr = new double[]{8.3,6.3,0.5};
        double expected = 15.1;
        double actual = arraz.sumOfDoublesArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1AverageOfArray(){
        int[] arr = new int[]{6,6};
        int expected = 6;
        int actual = arraz.averageOfArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2AverageOfArray(){
        int[] arr = new int[]{3,3,6};
        int expected = 4;
        int actual = arraz.averageOfArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1DoubleAverageOfArray(){
        double[] arr = new double[]{6.0,6.0};
        double expected = 6;
        double actual = arraz.doubleAverageOfArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2DoubleAverageOfArray(){
        double[] arr = new double[]{3,3,6};
        double expected = 4;
        double actual = arraz.doubleAverageOfArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1ContainsValue(){
        int[] arr = new int[]{2,5,6};
        int num = 5;
        boolean expected = true;
        boolean actual = arraz.containsValue(arr, num);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2ContainsValue(){
        int[] arr = new int[]{8,5,9};
        int num = 7;
        boolean expected = false;
        boolean actual = arraz.containsValue(arr, num);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1ReverseArray(){
        int[] arr = new int[]{3,1,9};
        int expected = 9;
        int[] actual = arraz.reverseArray(arr);
        Assert.assertEquals(expected, actual[0]);
    }

    @Test
    public void test2ReverseArray(){
        int[] arr = new int[]{6,11,9,7};
        int expected = 7;
        int[] actual = arraz.reverseArray(arr);
        Assert.assertEquals(expected, actual[0]);
    }

    @Test
    public void test1GetOddEvensOfArray(){
        int[] arr = new int[]{3,2,9};
        int expectedOdds = 2;
        int expectedEvens = 1;
        OddEven actual = arraz.getOddEvensOfArray(arr);
        Assert.assertEquals(expectedOdds, actual.odds);
        Assert.assertEquals(expectedEvens, actual.evens);
    }

    @Test
    public void test2GetOddEvensOfArray(){
        int[] arr = new int[]{6,11,4,7};
        int expectedOdds = 2;
        int expectedEvens = 2;
        OddEven actual = arraz.getOddEvensOfArray(arr);
        Assert.assertEquals(expectedOdds, actual.odds);
        Assert.assertEquals(expectedEvens, actual.evens);
    }

    @Test
    public void test1FindIndexOf(){
        int[] arr = new int[]{8,3,2,6};
        int expected = 1;
        int actual = arraz.FindIndexOf(arr, 3);
        org.junit.Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2FindIndexOf(){
        int[] arr = new int[]{8,3, 11, 9,6};
        int expected = -1;
        int actual = arraz.FindIndexOf(arr, 2);
        org.junit.Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1CopyArrayByInterator(){
        int[] arr = new int[]{5,6};
        int expected1 = 5;
        int expected2 = 6;
        int[] actual = arraz.copyArrayByIterator(arr);
        Assert.assertEquals(expected1, actual[0]);
        Assert.assertEquals(expected2, actual[1]);
    }

    @Test
    public void test2CopyArrayByInterator(){
        int[] arr = new int[]{0,3,6};
        int expected1 = 0;
        int expected2 = 3;
        int expected3 = 6;
        int[] actual = arraz.copyArrayByIterator(arr);
        Assert.assertEquals(expected1, actual[0]);
        Assert.assertEquals(expected2, actual[1]);
        Assert.assertEquals(expected3, actual[2]);
    }

    @Test
    public void test1CopyArrayByLoop(){
        int[] arr = new int[]{8,10};
        int expected1 = 8;
        int expected2 = 10;
        int[] actual = arraz.copyArrayByLoop(arr);
        Assert.assertEquals(expected1, actual[0]);
        Assert.assertEquals(expected2, actual[1]);
    }

    @Test
    public void test2CopyArrayByLoop(){
        int[] arr = new int[]{15,1,5};
        int expected1 = 15;
        int expected2 = 1;
        int expected3 = 5;
        int[] actual = arraz.copyArrayByLoop(arr);
        Assert.assertEquals(expected1, actual[0]);
        Assert.assertEquals(expected2, actual[1]);
        Assert.assertEquals(expected3, actual[2]);
    }

    @Test
    public void test1RemoveElementFromArray(){
        int[] arr = new int[]{8,10};
        int expected1 = 8;
        int[] actual = arraz.removeElementFromArray(arr, 10);
        Assert.assertEquals(expected1, actual[0]);
    }

    @Test
    public void test2RemoveElementFromArray() {
        int[] arr = new int[]{15, 1, 5};
        int expected1 = 15;
        int expected2 = 5;
        int[] actual = arraz.removeElementFromArray(arr,1);
        Assert.assertEquals(expected1, actual[0]);
        Assert.assertEquals(expected2, actual[1]);
    }
    //  insertIntoArrayAt

    @Test
    public void test1InsertIntoArrayAt(){
        int[] arr = new int[]{8,10};
        int expected1 = 8;
        int expected2 = 3;
        int expected3 = 10;
        int[] actual = arraz.insertIntoArrayAt(arr, 3, 1);
        Assert.assertEquals(expected1, actual[0]);
    }

    @Test
    public void test2InsertIntoArrayAt() {
        int[] arr = new int[]{15, 1, 5};
        int expected1 = 15;
        int expected2 = 1;
        int expected3 = 2;
        int[] actual = arraz.insertIntoArrayAt(arr, 2, 2);
        Assert.assertEquals(expected1, actual[0]);
        Assert.assertEquals(expected2, actual[1]);
        Assert.assertEquals(expected3, actual[2]);
    }

    @Test
    public void test1FindMaxMin(){
        int[] arr = new int[]{3,2,9};
        int expectedMax = 9;
        int expectedMin = 2;
        MaxMin actual = arraz.findMaxMin(arr);
        Assert.assertEquals(expectedMax, actual.max);
        Assert.assertEquals(expectedMin, actual.min);
    }

    @Test
    public void test2FindMaxMin(){
        int[] arr = new int[]{10, 20, 30, 4, 7, 23};
        int expectedMax = 30;
        int expectedMin = 4;
        MaxMin actual = arraz.findMaxMin(arr);
        Assert.assertEquals(expectedMax, actual.max);
        Assert.assertEquals(expectedMin, actual.min);
    }

    @Test
    public void test1RemoveDupesFromArray(){
        int[] arr = new int[]{1, 2, 3, 2, 1};
        int[] expected = new int[]{1,2, 3};
        int[] actual = arraz.removeDupesFromArray(arr);
        for(int i : actual)
            System.out.println(i);
        Assert.assertEquals(expected[0], actual[0]);
        Assert.assertEquals(expected[1], actual[1]);
        Assert.assertEquals(expected[2], actual[2]);
        Assert.assertEquals(expected.length, actual.length);
    }

    @Test
    public void test2RemoveDupesFromArray(){
        int[] arr = new int[]{5, 7, 7};
        int[] expected = new int[]{5, 7};
        int[] actual = arraz.removeDupesFromArray(arr);
        for(int i : actual)
            System.out.println(i);
        Assert.assertEquals(expected[0], actual[0]);
        Assert.assertEquals(expected[1], actual[1]);
    }

    @Test
    public void test1Find2ndLargestValueFromArray(){
        int[] arr = new int[]{5,3,1,8};
        int expected = 5;
        int actual = arraz.find2ndLargestValueFromArray(arr);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2Find2ndLargestValueFromArray(){
        int[] arr = new int[]{25,8,11,20};
        int expected = 20;
        int actual = arraz.find2ndLargestValueFromArray(arr);
        Assert.assertEquals(expected, actual);
    }

       @Test
       public void test1MakeMeAnArrayListFromArray(){
           int[] arr = {1,5,8};

           List<Integer> list = arraz.makeMeAnArrayListFromArray(arr);
         //  Assert.assertEquals(list.containsAll(Arrays.asList(arr)));

       }

       @Test
       public void test2MakeMeAnArrayListFromArray() {

            int[] arr = {1,5,8};
            List<Integer> list = arraz.makeMeAnArrayListFromArray(arr);

       }

       @Test
       public void test1MakeMeAnArrayFromArrayList(){
            List<Integer> list = new ArrayList<>();
            list.add(4);
            list.add(8);
            list.add(3);

            int[] arr = arraz.makemeAnArrayFromArrayList(list);
            Assert.assertEquals(list.size(), arr.length);
       }


        @Test
        public void test2MakeMeAnArrayFromArrayList(){
             List<Integer> list = new ArrayList<>();
             list.add(14);
             list.add(80);
             list.add(13);

             int[] arr = arraz.makemeAnArrayFromArrayList(list);
             Assert.assertEquals(list.size(), arr.length);
        }

           @Test
           public void test1Check2ArraysForEqual(){
               int[] arr = new int[]{5,3,1,8};
               int[] arr2 = new int[]{5,3,1,8};
               boolean expected = true;
               boolean actual = arraz.check2ArraysForEqual(arr, arr2);
               Assert.assertEquals(expected, actual);
           }

           @Test
           public void test2Check2ArraysForEqual(){

                int[] arr = new int[]{3,9,8};
                int[] arr2 = new int[]{5,3,1,8};

                boolean expected = false;

                boolean actual = arraz.check2ArraysForEqual(arr, arr2);
                Assert.assertEquals(expected, actual);
           }

            @Test
            public void test1AverageArrayWithoutMaxMin(){
                int[] arr = new int[]{6,8,9,1};
                int expected = 7;
                int actual = arraz.averageArrayWithoutMaxMin(arr);
                Assert.assertEquals(expected, actual);
            }

            @Test
            public void test2AverageArrayWithoutMaxMin(){
                int[] arr = new int[]{1,3,6};
                int expected = 3;
                int actual = arraz.averageArrayWithoutMaxMin(arr);
                Assert.assertEquals(expected, actual);
            }

            @Test
            public void test1ArrayHas65and77(){
                int[] arr = new int[]{65,18,9,77};
                boolean expected = true;
                boolean actual = arraz.arrayHas65and77(arr);
                Assert.assertEquals(expected, actual);
            }

            @Test
            public void test2ArrayHas65and77(){
                int[] arr = new int[]{51,83,96};
                boolean expected = false;
                boolean actual = arraz.arrayHas65and77(arr);
                Assert.assertEquals(expected, actual);
            }

            @Test
            public void test1TheTotalofTensIs30(){
                int[] arr = new int[]{65,10,9,10, 10,77};
                boolean expected = true;
                boolean actual = arraz.theTotalofTensIs30(arr);
                Assert.assertEquals(expected, actual);
            }

            @Test
            public void test2TheTotalofTensIs30(){
                int[] arr = new int[]{51,83,96, 10};
                boolean expected = false;
                boolean actual = arraz.theTotalofTensIs30(arr);
                Assert.assertEquals(expected, actual);
            }

            @Test
            public void test1FindSmallestAndSecondSmallest(){
                int[] arr = new int[]{5,3,1,8};
                int[] expected = {1,3};
                int[] actual = arraz.smallestAndSecondSmallest(arr);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
            }

            @Test
            public void test2FindSmallestAndSecondSmallest(){
                int[] arr = new int[]{50,9,13,5,8};
                int[] expected = {5, 9};
                int[] actual = arraz.smallestAndSecondSmallest(arr);
                Assert.assertEquals(expected.length, actual.length);
            }

            @Test
            public void test1MakeMeACopyPlease(){
                int[] arr = new int[]{5,3,1};
                int[] expected = {1,3,5};
                int[] actual = arraz.makeMeACopyPlease(arr);
                Assert.assertEquals(expected.length, actual.length);    
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
                Assert.assertEquals(expected[2], actual[2]);
            }

            @Test
            public void test2MakeMeACopyPlease(){
                int[] arr = new int[]{50,9};
                int[] expected = {9, 50};
                int[] actual = arraz.makeMeACopyPlease(arr);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
            }

            @Test
            public void test1RemoveLastItemAndCopy(){
                int[] arr = new int[]{5,3,1,6};                            
                int[] expected = {5,3,1};
                int[] actual = arraz.removeLastItemAndCopy(arr);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
                Assert.assertEquals(expected[2], actual[2]);
            }

            @Test
            public void test2RemoveLastItemAndCopy(){
                int[] arr = new int[]{50,9, 8};
                int[] expected = {50, 9};
                int[] actual = arraz.removeLastItemAndCopy(arr);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
            }

            @Test
            public void test1RemoveFirstItemAndCopy(){
                int[] arr = new int[]{5,3,1,6};
                int[] expected = {3,1, 6};
                int[] actual = arraz.removeFirstItemAndCopy(arr);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
                Assert.assertEquals(expected[2], actual[2]);
            }

            @Test
            public void test2RemoveFirstItemAndCopy(){
                int[] arr = new int[]{50,9, 8};
                int[] expected = {9, 8};
                int[] actual = arraz.removeFirstItemAndCopy(arr);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
            }

            @Test
            public void test1InsertAtStartAndCopy(){
                int[] arr = new int[]{50,9, 8};
                int[] expected = {3,50,9, 8};
                int[] actual = arraz.insertAtStartAndCopy(arr, 3);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
                Assert.assertEquals(expected[2], actual[2]);
                Assert.assertEquals(expected[3], actual[3]);
            }

            @Test
            public void test2InsertAtStartAndCopy(){
                int[] arr = new int[]{98, 34};
                int[] expected = {73,98,34};
                int[] actual = arraz.insertAtStartAndCopy(arr, 73);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
                Assert.assertEquals(expected[2], actual[2]);
            }

            @Test
            public void test1InsertAtEndAndCopy(){
                int[] arr = new int[]{50,9, 8};
                int[] expected = {50,9, 8, 3};
                int[] actual = arraz.insertAtEndAndCopy(arr, 3);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
                Assert.assertEquals(expected[2], actual[2]);
                Assert.assertEquals(expected[3], actual[3]);
            }

            @Test
            public void test2InsertAtEndAndCopy(){
                int[] arr = new int[]{98, 34};
                int[] expected = {98,34,73};
                int[] actual = arraz.insertAtEndAndCopy(arr, 73);
                Assert.assertEquals(expected.length, actual.length);
                Assert.assertEquals(expected[0], actual[0]);
                Assert.assertEquals(expected[1], actual[1]);
                Assert.assertEquals(expected[2], actual[2]);
            }

            @Test
            public void test1SortArrayIntoEvensThenOdds(){
               int[] arr = new int[]{5,3,1,6,4};
               int[] expected = {4,6,1,3,5};
               int[] actual = arraz.sortArrayIntoEvensThenOdds(arr);
               Assert.assertEquals(expected.length, actual.length);
               Assert.assertEquals(expected[0], actual[0]);
               Assert.assertEquals(expected[1], actual[1]);
               Assert.assertEquals(expected[2], actual[2]);
            }

            @Test
            public void test2SortArrayIntoEvensThenOdds(){
              int[] arr = new int[]{9,3,2,6};
              int[] expected = {2, 6, 3, 9};
              int[] actual = arraz.sortArrayIntoEvensThenOdds(arr);
              Assert.assertEquals(expected.length, actual.length);
              Assert.assertEquals(expected[0], actual[0]);
              Assert.assertEquals(expected[1], actual[1]);
              Assert.assertEquals(expected[2], actual[2]);
            }
}